<template>
    <div>
        <ErrorComponent :error-value="error" class="w"/>
        <SuccessComponent :success-value="success" class="w"/>
        <div class="holder">
            <div class="left">
                <div class="fp" :style="Style">
                    <img class="max" :src="floorplan.info.image">

                    <canvas id='canvas' width="10000" height="10000" class="max">

                    </canvas>
                    <div v-for="a in positions" class="dot"
                         :style="{left: a.x + '%' , top: a.y + '%', background: a.color}">

                        <div class="name">{{a.name}}</div>
                    </div>
                </div>

            </div>
            <div class="right">
                <v-row>

                    <v-text-field class="ma-1" label="speed" v-model="speed"/>
                    <v-text-field class="ma-1" label="update rate" v-model="rate"/>
                    <v-btn @click="Simulate" class="ma-1" color="primary">{{simulating ? "stop" : "start"}}</v-btn>
                </v-row>
                <v-list class="list-full" three-line>
                    <v-list-item :class='selected === w.light.id ? "border": ""' :key="w.light.id" :value="w.light.id"
                                 v-for="(w,i) in workers">
                        <v-list-item-avatar>
                            <v-img :src="w.light.image"/>
                        </v-list-item-avatar>

                        <v-list-item-content>
                            <v-list-item-title v-html="w.light.name"></v-list-item-title>
                            <v-list-item-subtitle>
                                {{GetX(w.light.id)}},
                                {{GetY(w.light.id)}}
                            </v-list-item-subtitle>
                            <v-list-item-subtitle>
                                {{GetMemory(w.light.id)}}
                            </v-list-item-subtitle>
                        </v-list-item-content>
                        <v-list-item-action class="flex-row">
                            <v-btn @click='selected=w.light.id' class="ma-1" color="primary"
                                   v-if='selected !== w.light.id'>Select
                            </v-btn>
                            <v-btn @click="CopyComplete(w.light.id)" class="ma-1" color="primary" icon v-if='copyMode'>
                                <v-icon>$vuetify.icons.check</v-icon>
                            </v-btn>
                            <v-btn @click="Add(w.light.id)" class="ma-1" color="primary" icon>
                                <v-icon>$vuetify.icons.add</v-icon>
                            </v-btn>
                            <v-btn :color="copyMode ? 'disabled': 'primary'" @click="Copy(w.light.id)" class="ma-1"
                                   icon>
                                <v-icon>$vuetify.icons.copy</v-icon>
                            </v-btn>
                            <v-btn @click="Clear(w.light.id)" class="ma-1" color="primary" icon>
                                <v-icon>$vuetify.icons.close</v-icon>
                            </v-btn>
                            <v-checkbox color="deep-purple accent-4" v-model="sync[i]">Sync</v-checkbox>
                        </v-list-item-action>
                    </v-list-item>
                </v-list>
            </div>
        </div>


    </div>
</template>

<style lang='scss' scoped>
    .border {
        border: 2px dashed orange;
    }

    .list-full {
        height: 90vh;
        overflow-y: auto;
    }

    .holder {
        width: 100%;
        display: flex;

        .left {
            width: 70%
        }

        .right {
            width: 30%;
        }

    }

    .dot {
        transform: translate(-50%, -50%);
        position: absolute;


        transition: left 0.2s, top 0.2s;

        .name {
            background: white;
            transform: translate(-50%, -100%);
        }

        width: 15px;
        height: 15px;
        border-radius: 50%;
    }

    .fp {
        position: relative;
        margin: auto;
    }

    .max {
        display: block;
        position: absolute;
        width: 100%;
        height: 100%;
    }
</style>

<script lang='ts'>
    import {Component, Prop, Vue, Watch} from 'vue-property-decorator';
    import {$$, coreApi} from "../../init";
    import {Route} from "vue-router";
    import {FloorResponse} from "../../../../classLibrary/core/floorResponse";
    import {FloorPlanFullResponse} from "../../../../classLibrary/core/floorPlanFullResponse";
    import {FloorPlanFlyWeightResponse} from "../../../../classLibrary/core/floorPlanFlyWeightResponse";
    import ErrorComponent from "../../components/ErrorComponent.vue";
    import SuccessComponent from "../../components/SuccessComponent.vue";
    import {WorkerPositionResponse} from "../../../../classLibrary/core/workerPositionResponse";
    import {Drawer} from "../../../../classLibrary/Drawer";
    import {Validable} from "../../mixins/Validable";
    import {Mixins} from "vue-mixin-decorator";
    import {Q} from "../../../../classLibrary/Geometry/Quad";
    import {P} from "../../../../classLibrary/Geometry/Point";
    import {WorkerResponse} from "../../../../classLibrary/core/workerResponse";
    import moment from "moment";
    import {BStorage} from "../../../../classLibrary/Storage";


    type Position = { x: number, y: number, name: string, id: string, color: string }
    type Path = { x: number, y: number }[]

    @Component({
        components: {ErrorComponent, SuccessComponent}
    })
    export default class Floor extends Mixins<Validable>(Validable) {


        @Prop() store!: BStorage;
        positions: Position[] = [];
        floorId: string = "";
        floorplanId: string = "";
        floorplan: FloorPlanFullResponse = new FloorPlanFullResponse(new FloorPlanFlyWeightResponse("", "", "", [], 0, 0,), [], []);

        sync: boolean[] = [];
        speed = 5;
        rate = 1000;
        temp = 0;
        selected = '';
        workers: WorkerResponse[] = [];

        ram: { [s: string]: Path } = {};

        copyTarget: string = '';
        copyMode: boolean = false;

        simulating = false;

        get StoreKey(): string {
            return `floor-store-mem-${this.floorId}`;
        }

        Simulate() {
            if (this.simulating) {
                this.simulating = false;
            } else {
                this.simulating = true;
                this.FakeUpdate(new Date());
            }
        }

        async FakeUpdate(time: Date): Promise<void> {
            if (!this.simulating) {
                return;
            }
            const updated = moment(time).add(3, "minute").toDate();
            const local = moment(updated).tz(this.store.value.tz);
            if (local.hour() < 18 && local.hour() > 8) {
                for (let i = 0; i < this.positions.length; i++) {
                    const e = this.positions[i];
                    const r = this.ram[e.id].Random();
                    Vue.set(this.positions[i], 'x', r?.x)
                    Vue.set(this.positions[i], 'y', r?.y)
                }
                await this.updateAll(true, updated.toISOString());
                await $$(250);
            }
            this.FakeUpdate(updated).then();
        }

        Clear(id: string) {
            this.ram[id] = [];
            this.SaveToRAM();
        }

        GetMemory(id: string): string {
            if (this.ram[id]) {
                return this.ram[id].Map(x => `(${x.x}, ${x.y})`).join(" ");
            } else {
                return "";
            }
        }

        Add(id: string) {
            const [x, y] = [this.GetX(id), this.GetY(id)];

            if (!this.ram[id]) this.ram[id] = [];
            this.ram[id].push({x: x.ToFloat(), y: y.ToFloat()});

            this.SaveToRAM();
        }

        CopyComplete(id: string) {

            this.ram[id] = this.ram[this.copyTarget] ?? [] as Path;

            this.copyTarget = '';
            this.copyMode = false;
            this.SaveToRAM();
        }

        Copy(id: string) {
            this.copyTarget = id;
            this.copyMode = true;
        }

        GetX(id: string): string {
            return this.GetPosition(id)?.x?.toString() ?? "";
        }

        GetY(id: string): string {
            return this.GetPosition(id)?.y?.toString() ?? "";
        }

        GetPosition(id: string): Position | null {
            return this.positions.Find(x => x.id === id);
        }

        move(event: KeyboardEvent) {
            const id = this.selected;

            let index = this.positions.FindIndex(x => x.id === id);

            if (index == null) {
                const worker = this.workers.Find(x => x.light.id === id)!;
                this.positions.push({
                    x: 0,
                    y: 0,
                    name: worker.light.name,
                    id: worker.light.id,
                    color: worker.subContractor.color
                });
                index = this.positions.length - 1;
            }
            console.log("moving", index, this.selected);
            if (event.keyCode == 37 || event.keyCode == 65) {
                const x = (this.positions[index].x - this.speed.ToFloat()).AtMax(100).AtMin(0);
                Vue.set(this.positions[index], 'x', x);
                event.preventDefault();
            } else if (event.keyCode == 39 || event.keyCode == 68) {
                const x = (this.positions[index].x + this.speed.ToFloat()).AtMax(100).AtMin(0)
                Vue.set(this.positions[index], 'x', x);
                event.preventDefault();
            } else if (event.keyCode == 38 || event.keyCode == 87) {
                const y = (this.positions[index].y - this.speed.ToFloat()).AtMax(100).AtMin(0)
                Vue.set(this.positions[index], 'y', y);
                event.preventDefault();
            } else if (event.keyCode == 40 || event.keyCode == 83) {
                const y = (this.positions[index].y + this.speed.ToFloat()).AtMax(100).AtMin(0)
                Vue.set(this.positions[index], 'y', y);
                event.preventDefault();
            }

        }

        async init() {
            const wR = await coreApi.Get<WorkerResponse[]>('Worker');
            if (wR.success) {
                this.workers = wR.Ok!;
                this.sync = [].Fill(wR.Ok!.length, () => false);
            }
            this.floorId = this.$route.params.id;
            const r = await coreApi.Get<FloorResponse>(`Floor/${this.floorId}`);
            if (!r.success) await this.$router.push("not found");
            const fp = r.Ok!.latestFloorPlan.id;
            this.floorplanId = fp;
            const fr = await coreApi.Get<FloorPlanFullResponse>(`FloorPlan/${this.floorId}/${fp}`);
            if (!fr.success) this.err = fr.error!;
            this.floorplan = fr.Ok!;
            this.temp = (0).RandomTo(1000000, true);
            await this.updateStack(this.temp);
            this.ram = JSON.parse(localStorage.getItem(this.StoreKey) ?? "{}");
        }

        SaveToRAM() {
            const ram = JSON.stringify(this.ram);
            localStorage.setItem(this.StoreKey, ram);
        }

        destroyed() {
            // deallocate stack
            this.temp = this.temp - 10;
            document.removeEventListener('keydown', this.move);
        }


        async updateAll(auto: boolean, date?: string): Promise<void> {
            const r = this.workers
                .Where((e, i) => this.sync[i] || auto)
                .Map(e => [e, this.positions.Find(x => x.id === e.light.id)] as [WorkerResponse, Position])
                .Where(([e, p]) => p != null)
                .Map(([e, p]) => {
                    const xP = p.x / 100;
                    const yP = p.y / 100;
                    const x = xP * this.floorplan.info.width;
                    const y = yP * this.floorplan.info.height;
                    return {
                        floorId: this.floorId,
                        mac: e.tag.macAddress,
                        x, y,
                    }
                });
            const proxy = date ? `Proxy/batch?alternateStamp=${date}` : 'Proxy/batch';
            if (r.length > 0) {
                await coreApi.QPost(proxy, r)
            }

        }

        async push() {
            await this.updateAll(false);
            await $$(this.rate);
            this.push().then();
        }

        async updateStack(a: number) {
            if (this.temp != a)
                return
            const x = await coreApi.Get<{ [s: string]: WorkerPositionResponse }>(`History/${this.floorId}`);
            if (x.Ok) {

                for (let key in x.Ok!) {
                    if (x.Ok!.hasOwnProperty(key)) {
                        const v = x.Ok![key];
                        const index = this.positions.FindIndex(x => x.id == key);
                        const pos = {
                            x: v.x / this.floorplan.info.width * 100,
                            y: v.y / this.floorplan.info.height * 100,
                            name: v.name,
                            id: key,
                            color: v.color,
                        }
                        if (index == null) {
                            this.positions.push(pos)
                        } else {
                            Vue.set(this.positions, index, pos)
                        }
                    }
                }
            } else {
                this.err = x.error!;
            }
        }

        async created() {
            await this.init();
            this.push();

        }

        async mountInit() {
            const c = document.getElementById("canvas") as HTMLCanvasElement;

            const ww = window.innerWidth;
            const wh = window.innerHeight;

            const w = ww / 2;
            const h = wh / 2;
            c.width = w.ToFloat();
            c.height = h.ToFloat();

            const ctx = c.getContext("2d")!;
            this.draw = new Drawer(this.floorplan.info.width, this.floorplan.info.height, w.ToFloat(), h.ToFloat(), ctx);

            const colors = this.floorplan.areas
                .Map(a => {
                        const c = (this.floorplan.info.zoneData as any)[a.areaId].color;
                        a.maps.Each(m => {
                            const q = Q(m);
                            this.draw.DrawArea(q.Quad, a.areaId, c, (this.floorplan.info.zoneData as any)[a.areaId].danger)
                        });
                        return [a.areaId, c];
                    }
                )
                .AsValue(([id, c]) => id)
                .MapValue(([k, v]) => v as string);

            const cc = Object.fromEntries(colors) as { [s: string]: string };

            this.floorplan.exits.Each(e => {
                const p1 = P(e.pt1).Point;
                const p2 = P(e.pt2).Point;

                this.draw.DrawExit([p1, p2], cc[e.area1], cc[e.area2]);
            });
        }

        draw: Drawer = new Drawer(0, 0, 0, 0, {} as CanvasRenderingContext2D);

        async mounted() {
            await this.mountInit();

            document.removeEventListener('keydown', this.move);
            document.addEventListener('keydown', this.move);
        }

        ww = 60;


        get Style() {
            return {
                width: this.ww + "vw",
                height: this.ww / this.floorplan.info.width * this.floorplan.info.height + "vw"
            }
        }

        @Watch('$route', {immediate: true, deep: true})
        async onUrlChange(newVal: Route) {
            await this.init();
            await this.mountInit();
        }
    }


</script>
